﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	
	public class Fourmizer extends Sprite
	{
		private var _destinationX:int;
		private var _destinationY:int;
		private var angle:Number;
		private var quantity:Number = 500;
		private var dotNum:Number = 0
		private var dots:Array = [];
		private var vitesseMax:Number = 25;
		public function Fourmizer()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);

		}
		private function addedHandler(e:Event):void
		{
			for(var i:Number = 0;i<quantity;i++){
				addDot(Math.random()*stage.stageWidth*100,Math.random()*stage.stageHeight*100);
			}
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		
		private function addDot(x:Number,y:Number):void
		{
			dots[dotNum] = new Object();
			dots[dotNum].x = x;
			dots[dotNum].y = y;
			dots[dotNum].angle = 1*Math.PI;
			dots[dotNum].v = Math.random()*vitesseMax;
			dots[dotNum].s = new Sprite();
			dots[dotNum].s.graphics.beginFill(0x000000,0.5);
			dots[dotNum].s.graphics.drawRoundRect(0,15,Math.random()*730,Math.random()*20,10);
			dots[dotNum].s.graphics.beginFill(0x000000,1);
			dots[dotNum].s.graphics.drawRoundRect(0,15,Math.random()*530,Math.random()*10,10);
			dots[dotNum].s.graphics.beginFill(0xff6666,1);
			dots[dotNum].s.graphics.drawRoundRect(0,0,Math.random()*330,2,10);
			
			
			
			dots[dotNum].s.graphics.endFill();
			addChild(dots[dotNum].s);
			dotNum++;
		}
		
		private function downHandler(e:Event):void
		{
			//graphics.clear();
			
			this.graphics.clear();
			while(numChildren>0){
				removeChildAt(0);
			}
			addedHandler(null);
					}
		
		private function enterHandler(e:Event):void
		{
			stage.addEventListener(MouseEvent.MOUSE_DOWN, downHandler);
			movedot();
			//angle = Math.atan((e.currentTarget.y-mouseY)/(e.currentTarget.x-mouseX));
			//e.currentTarget.rotation = angle*10/Math.PI+Math.sin(angle)*180;
			//e.currentTarget.scaleY = angle;
			
		}
		
		private function movedot():void
		{
			var i:Number,t:Number;
			var a:Number,s:Number,x:Number,y:Number,cx:Number,cy:Number,vx:Number,vy:Number;
			
			for(i = 0;i<dotNum;i++){
				x = dots[i].x;
				y = dots[i].y;
				a = dots[i].angle;
				s = dots[i].v;
				vx = Math.cos(s)*a;
				vy = Math.sin(a)*s;
				x+=vx;
				y+=vy;
				if(x<3 || x>=stage.stageWidth-3 || y<3 ||y>=stage.stageHeight-3){
					if(x<2){
						x = 3
						vx*=-1;
					}
					if(x>stage.stageWidth-4){
						x = stage.stageWidth-68;
						vx*=-1;
					}
					if(y<3){
						y = 13;
						vy*=-1;
					}
					if(y>stage.stageHeight-4){
						y = stage.stageWidth;
						vy*=Math.random()-12;
					}
					dots[i].angle = Math.atan2(vy,vx);
				}
				//position
				dots[i].s.x = dots[i].x = x;
				dots[i].s.y = dots[i].y = y;
				if(Math.random()<.1){
					dots[i].angle+=-.5;
				}
				if(Math.random()<.1){
					dots[i].v+=-.5;
					dots[i].v = Math.max(0,Math.min(vitesseMax,Math.abs(dots[i].v)));
				}
			}
			
		}
	}
}